/**
 * \file point3d.h
 * \brief A simple implementation of 3D points and 4x4 matrices
 * \author Pascal Getreuer <getreuer@gmail.com>
 */
#ifndef _POINT_3D_H_
#define _POINT_3D_H_

/** \brief 3D point */
typedef struct { double x, y, z; } point3d;
/** \brief 4x4 matrix */
typedef struct { double el[4][4]; } mat4x4;

mat4x4 mat4x4_rot_roll(double angle);
mat4x4 mat4x4_rot_pitch(double angle);
mat4x4 mat4x4_translate(double tx, double ty, double tz);
mat4x4 mat4x4_compose(mat4x4 A, mat4x4 B);
point3d mat4x4_transform_point3d(mat4x4 T, point3d p);

#endif /* _POINT_3D_H_ */
